/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the TemplateGroupedTemplatesInner type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &TemplateGroupedTemplatesInner{}

// TemplateGroupedTemplatesInner struct for TemplateGroupedTemplatesInner
type TemplateGroupedTemplatesInner struct {
	Id string `json:"id"`
	Status string `json:"status"`
	Language string `json:"language"`
	RejectedReason *string `json:"rejected_reason,omitempty"`
}

// NewTemplateGroupedTemplatesInner instantiates a new TemplateGroupedTemplatesInner object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewTemplateGroupedTemplatesInner(id string, status string, language string) *TemplateGroupedTemplatesInner {
	this := TemplateGroupedTemplatesInner{}
	this.Id = id
	this.Status = status
	this.Language = language
	return &this
}

// NewTemplateGroupedTemplatesInnerWithDefaults instantiates a new TemplateGroupedTemplatesInner object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewTemplateGroupedTemplatesInnerWithDefaults() *TemplateGroupedTemplatesInner {
	this := TemplateGroupedTemplatesInner{}
	return &this
}

// GetId returns the Id field value
func (o *TemplateGroupedTemplatesInner) GetId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Id
}

// GetIdOk returns a tuple with the Id field value
// and a boolean to check if the value has been set.
func (o *TemplateGroupedTemplatesInner) GetIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Id, true
}

// SetId sets field value
func (o *TemplateGroupedTemplatesInner) SetId(v string) {
	o.Id = v
}

// GetStatus returns the Status field value
func (o *TemplateGroupedTemplatesInner) GetStatus() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Status
}

// GetStatusOk returns a tuple with the Status field value
// and a boolean to check if the value has been set.
func (o *TemplateGroupedTemplatesInner) GetStatusOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Status, true
}

// SetStatus sets field value
func (o *TemplateGroupedTemplatesInner) SetStatus(v string) {
	o.Status = v
}

// GetLanguage returns the Language field value
func (o *TemplateGroupedTemplatesInner) GetLanguage() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Language
}

// GetLanguageOk returns a tuple with the Language field value
// and a boolean to check if the value has been set.
func (o *TemplateGroupedTemplatesInner) GetLanguageOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Language, true
}

// SetLanguage sets field value
func (o *TemplateGroupedTemplatesInner) SetLanguage(v string) {
	o.Language = v
}

// GetRejectedReason returns the RejectedReason field value if set, zero value otherwise.
func (o *TemplateGroupedTemplatesInner) GetRejectedReason() string {
	if o == nil || IsNil(o.RejectedReason) {
		var ret string
		return ret
	}
	return *o.RejectedReason
}

// GetRejectedReasonOk returns a tuple with the RejectedReason field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TemplateGroupedTemplatesInner) GetRejectedReasonOk() (*string, bool) {
	if o == nil || IsNil(o.RejectedReason) {
		return nil, false
	}
	return o.RejectedReason, true
}

// HasRejectedReason returns a boolean if a field has been set.
func (o *TemplateGroupedTemplatesInner) HasRejectedReason() bool {
	if o != nil && !IsNil(o.RejectedReason) {
		return true
	}

	return false
}

// SetRejectedReason gets a reference to the given string and assigns it to the RejectedReason field.
func (o *TemplateGroupedTemplatesInner) SetRejectedReason(v string) {
	o.RejectedReason = &v
}

func (o TemplateGroupedTemplatesInner) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o TemplateGroupedTemplatesInner) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["id"] = o.Id
	toSerialize["status"] = o.Status
	toSerialize["language"] = o.Language
	if !IsNil(o.RejectedReason) {
		toSerialize["rejected_reason"] = o.RejectedReason
	}
	return toSerialize, nil
}

type NullableTemplateGroupedTemplatesInner struct {
	value *TemplateGroupedTemplatesInner
	isSet bool
}

func (v NullableTemplateGroupedTemplatesInner) Get() *TemplateGroupedTemplatesInner {
	return v.value
}

func (v *NullableTemplateGroupedTemplatesInner) Set(val *TemplateGroupedTemplatesInner) {
	v.value = val
	v.isSet = true
}

func (v NullableTemplateGroupedTemplatesInner) IsSet() bool {
	return v.isSet
}

func (v *NullableTemplateGroupedTemplatesInner) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableTemplateGroupedTemplatesInner(val *TemplateGroupedTemplatesInner) *NullableTemplateGroupedTemplatesInner {
	return &NullableTemplateGroupedTemplatesInner{value: val, isSet: true}
}

func (v NullableTemplateGroupedTemplatesInner) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableTemplateGroupedTemplatesInner) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


